# ioctl
ioctl is a command-line interface for interacting with IoTeX blockchains.

# Build
`./buildcli.sh`


If you want to build ioctl on Windows, you need to install mingw. Package manager [Chocolatey](https://chocolatey.org/) provides an easy way to intall latest mingw.
`C:\Windows\system32> choco install mingw`


After this command, target bin files will be placed in ./release/ folder, upload them to
specific release so install-cli.sh can download them.

# Install
## Install released build
    curl --silent https://raw.githubusercontent.com/iotexproject/iotex-core/master/install-cli.sh | sh

## Install latest build
    curl https://raw.githubusercontent.com/iotexproject/iotex-core/master/install-cli.sh | sh -s "unstable"
## ioctl

Command-line interface for IoTeX blockchain

### Synopsis

ioctl is a command-line interface for interacting with IoTeX blockchain.

### Options

```
  -h, --help                   help for ioctl
  -o, --output-format string   output format
```

### SEE ALSO

* [ioctl account](readme/ioctl_account.md)	 - Manage accounts of IoTeX blockchain
* [ioctl action](readme/ioctl_action.md)	 - Manage actions of IoTeX blockchain
* [ioctl alias](readme/ioctl_alias.md)	 - Manage aliases of IoTeX addresses
* [ioctl bc](readme/ioctl_bc.md)	 - Deal with block chain of IoTeX blockchain
* [ioctl config](readme/ioctl_config.md)	 - Get, set, or reset configuration for ioctl
* [ioctl contract](readme/ioctl_contract.md)	 - Deal with smart contract of IoTeX blockchain
* [ioctl did](readme/ioctl_did.md)	 - DID command
* [ioctl hdwallet](readme/ioctl_hdwallet.md)	 - Manage hdwallets of IoTeX blockchain
* [ioctl jwt](readme/ioctl_jwt.md)	 - Manage Json Web Token on IoTeX blockchain
* [ioctl node](readme/ioctl_node.md)	 - Deal with nodes of IoTeX blockchain
* [ioctl stake2](readme/ioctl_stake2.md)	 - Support native staking of IoTeX blockchain
* [ioctl update](readme/ioctl_update.md)	 - Update ioctl with latest version
* [ioctl version](readme/ioctl_version.md)	 - Print the version of ioctl and node
* [ioctl xrc20](readme/ioctl_xrc20.md)	 - Support ERC20 standard command-line

###### Auto generated by docgen on 7-Mar-2022
